use std::process::exit;
use std::path::PathBuf;

use colored::*;

use gclone::{first_arg, Cache, Result};
use gclone::git::{GCLONE_PATH, parse_url, clone};

fn help() {

}

fn main_result() -> Result<()> {

    // Parse args
    let url = first_arg()?;

    if url == "-h" || url == "--help" {
        return Ok(help());
    }

    let (server, owner, repo) = parse_url(&url)?;

    // Build path
    let mut path = PathBuf::from(&*GCLONE_PATH);
    path.push(&server);
    path.push(&owner);
    path.push(&repo);

    // Clone repository
    eprintln!("{} {} {}{}", "info:".bold(), "cloning", url, "...");
    clone(&url, &path.display().to_string())?;
    eprintln!("{} {}", "info:".bold(), "done!");

    // Append to cache
    let mut cache = Cache::read()?;
    cache.append(path.display().to_string());
    cache.write()?;

    Ok(())

}

fn main() {
    if let Err(e) = main_result() {
        eprintln!("{}", e);
        exit(1);
    }
}
